#include "LibItsMbr_EncdecDeclarations.hh"

#include "etsi_ts103759_data_codec.hh"

#include "loggers.hh"

namespace LibItsMbr__EncdecDeclarations {

  BITSTRING fx__enc__EtsiTs103759Data(const EtsiTs103759Core::EtsiTs103759Data &p_etsi_ts_103759_data) {
    loggers::get_instance().log_msg(">>> fx__enc__EtsiTs103759Data: ", p_etsi_ts_103759_data);

    etsi_ts103759_data_codec codec;
    OCTETSTRING              os;
    if (codec.encode(p_etsi_ts_103759_data, os) == -1) {
      loggers::get_instance().warning("fx__enc__EtsiTs103759Data: -1 result code was returned");
      return int2bit(0, 1);
    }

    return oct2bit(os);
  }

  INTEGER fx__dec__EtsiTs103759Data(BITSTRING &b, EtsiTs103759Core::EtsiTs103759Data &p_etsi_ts_103759_data) {
    loggers::get_instance().log_msg(">>> fx__dec__EtsiTs103759Data: ", b);

    etsi_ts103759_data_codec codec;
    OCTETSTRING              is = bit2oct(b);
    if (codec.decode(is, p_etsi_ts_103759_data) == -1) {
      loggers::get_instance().warning("fx__dec__EtsiTs103759Data: -1 result code was returned");
      return -1;
    }

    return 0;
  }


} // End of namespace LibItsMbr__EncdecDeclarations
