#!/bin/bash

#set -e
set -vx

BASE_PATH=`pwd`

git checkout ttf_t024
git submodule update --init --recursive --remote

for i in `find $BASE_PATH/ttcn -type d -name "Ats*"`
do
    cd $i
    git checkout devel2
done
for i in `find $BASE_PATH/ttcn/Ats* -type d -name "asn1"`
do
    cd $i
    git checkout testing2
    if [ -f ETSI-ITS-CDD.asn ]
    then
        ln -sf ETSI-ITS-CDD.asn ETSI_ITS_CDD.asn
    elif [ -f IVIM-PDU-Descriptions.asn ]
    then
        ln -sf IVIM-PDU-Descriptions.asn IVIM_PDU_Descriptions.asn
        ln -sf MAPEM-PDU-Descriptions.asn MAPEM_PDU_Descriptions.asn
        ln -sf RTCMEM-PDU-Descriptions.asn RTCMEM_PDU_Descriptions.asn
        ln -sf SPATEM-PDU-Descriptions.asn SPATEM_PDU_Descriptions.asn
        ln -sf SREM-PDU-Descriptions.asn SREM_PDU_Descriptions.asn
        ln -sf SSEM-PDU-Descriptions.asn SSEM_PDU_Descriptions.asn
        cd ./iso-patched
        ln -sf 'ISO14906(2018)EfcDsrcApplicationv6-patched.asn' EfcDsrcApplication.asn
        ln -sf 'ISO14906(2018)EfcDsrcGenericv7-patched.asn' EfcDsrcGeneric.asn
        ln -sf ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn ElectronicRegistrationIdentificationVehicleDataModule.asn
        ln -sf ISO14823-missing.asn GDD.asn
        cd -
    fi
    SUB_DIRS=`find . -type d`
    if [ "SUB_DIRS" != "" ]
    then
        for j in $SUB_DIRS
        do
            cd $j
            git checkout testing2
            cd -
        done
    fi
done

cd $BASE_PATH
if [ ! -f ./titan-test-system-framework ]
then
    git clone --recurse-submodules --single-branch --branch devel https://labs.etsi.org/rep/cti-tools/titan-test-system-framework.git
    cd ./titan-test-system-framework
else
    cd ./titan-test-system-framework
    git checkout devel
fi
cd ./ttcn/LibHttp
ln -sf module_its.mk module.mk

cd $BASE_PATH/ttcn/LibIts
git checkout devel2

cd $BASE_PATH
cp ./ttcn/patch_lib_common_titan/module.mk ./ttcn/LibCommon/
cp ./ttcn/patch_lib_common_titan/ttcn/* ./ttcn/LibCommon/ttcn


exit 0
